Summary: DHCPv6 - DHCP server and client for IPv6
Name:    dhcpv6
Version: 0.10
Release: 42%{?dist}
License: GPL
Group:   System Environment/Daemons
URL:     http://dhcpv6.sourceforge.net/
Source0: ftp://ftp.sourceforge.net/pub/sourceforge/d/dh/dhcp/dhcp-%{version}.tgz
Source1: libdhcp6client.pc
Source2: rfc3315.txt

Patch0:  %{name}-0.10-redhat.patch
Patch1:  %{name}-0.10-relay.patch
Patch2:  %{name}-0.10-man.patch
Patch3:  %{name}-0.10-gethwid.patch
Patch4:  %{name}-0.10-no-strlcat.patch
Patch5:  %{name}-0.10-salen.patch
Patch6:  %{name}-0.10-initscripts.patch

Patch99: %{name}-0.10-libdhcp6client.patch

Prereq: /sbin/chkconfig, /sbin/service
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: flex, bison, openssl-devel, autoconf, automake, libtool

%description
Implements the Dynamic Host Configuration Protocol (DHCP) for Internet
Protocol version 6 (IPv6) networks in accordance with RFC 3315: Dynamic Host
Configuration Protocol for IPv6 (DHCPv6).  Consists of dhcp6s(8), the server
DHCP daemon, and dhcp6r(8), the DHCPv6 relay agent.

Install this package if you want to support dynamic configuration of IPv6
addresses and parameters on your IPv6 network.  See man dhcp6s(8), dhcp6r(8),
dhcp6s.conf(5), and the documentation in /usr/share/doc/dhcpv6*.

%package -n dhcpv6_client
Summary:  DHCPv6 client
Requires: initscripts >= 7.73
Group: System Environment/Base

%description -n dhcpv6_client
Provides the client for the DHCPv6 protocol (RFC 3315) to support dynamic
configuration of IPv6 addresses and parameters.  See man dhcp6c(8),
dhcp6c.conf(5), and the documentation in /usr/share/dhcpv6_client*.

%package -n libdhcp6client
Summary: The DHCPv6 client in a library for invocation by other programs
Group:  Development/Libraries

%description -n libdhcp6client
Provides the client for the DHCPv6 protocol (RFC 3315) to support dynamic
configuration of IPv6 addresses and parameters, in a library for invocation
by other programs.

%package -n libdhcp6client-devel
Summary: Header files for development with the DHCPv6 client library
Group:   Development/Libraries

%description -n libdhcp6client-devel
Header files for development with the DHCPv6 client library.

%prep
%setup -q -n dhcp-%{version}
%patch0 -p1 -b .rh
%patch1 -p1 -b .relay
%patch2 -p1 -b .man
%patch3 -p1 -b .gethwid
%patch4 -p1 -b .no_strlcat
%patch5 -p1 -b .salen
%patch6 -p1 -b .initscripts

%patch99 -p1 -b .libdhcp6client

%{__cp} -fp %{SOURCE2} docs

# these things are part of glibc
%{__rm} -f ifaddrs.c ifaddrs.h queue.h

# we don't need these things
%{__rm} -f strlcat.c

autoconf

%build
%configure --prefix=/ --mandir=%{_mandir}
%{__make}
%{__make} -C libdhcp6client

%install
%{__rm} -rf %{buildroot}
%{__sed} 's/@DHCPV6_VERSION@/'%{version}'/' < %{SOURCE1} > libdhcp6client.pc
%{__make} install DESTDIR=%{buildroot} \
                  LIBDIR=%{_libdir} \
                  PKGCFGDIR=%{_libdir}/pkgconfig \
                  INSTALL_USER=`%{__id} -un` \
                  INSTALL_GROUP=`%{__id} -gn`
%{__make} -C libdhcp6client install DESTDIR=%{buildroot} \
                                    LIBDIR=%{_libdir} \
                                    PKGCFGDIR=%{_libdir}/pkgconfig \
                                    INSTALL_USER=`%{__id} -un` \
                                    INSTALL_GROUP=`%{__id} -gn`

%{__mkdir} -p %{buildroot}%{_localstatedir}/lib/%{name}

%post
chkconfig --add dhcp6s

%preun
if [ $1 = 0 ]; then
    service dhcp6s stop > /dev/null 2>&1
    chkconfig --del dhcp6s
fi

%postun
if [ "$1" -ge "1" ]; then
    service dhcp6s condrestart >/dev/null 2>&1
fi
exit 0

%post -n libdhcp6client -p /sbin/ldconfig

%postun -n libdhcp6client -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%attr(754,root,root) %{_sbindir}/dhcp6s
%attr(754,root,root) %{_sbindir}/dhcp6r
%attr(755,root,root) %config /etc/rc.d/init.d/dhcp6s
%attr(755,root,root) %config /etc/rc.d/init.d/dhcp6r
%config(noreplace) /etc/sysconfig/dhcp6s
%config(noreplace) /etc/sysconfig/dhcp6r
%{_mandir}/man8/dhcp6s.8.gz
%{_mandir}/man5/dhcp6s.conf.5.gz
%{_mandir}/man8/dhcp6r.8.gz
%attr(750,root,root) %dir %{_localstatedir}/lib/dhcpv6

%doc ReadMe docs/* dhcp6s.conf

%files -n dhcpv6_client
%defattr(-,root,root,-)
%attr(750,root,root) /sbin/dhcp6c
%{_mandir}/man8/dhcp6c.8.gz
%{_mandir}/man5/dhcp6c.conf.5.gz
%doc ReadMe dhcp6c.conf
%attr(750,root,root) %dir %{_localstatedir}/lib/dhcpv6

%files -n libdhcp6client
%defattr(0755,root,root,0755)
%{_libdir}/libdhcp6client-%{version}.so.*

%files -n libdhcp6client-devel
%defattr(0644,root,root,0755)
%{_includedir}/*
%{_libdir}/pkgconfig/libdhcp6client.pc
%defattr(-,root,root,-)
%{_libdir}/libdhcp6client.so
%{_libdir}/libdhcp6client.a

%changelog
* Thu Apr 26 2007 David Cantrell <dcantrell@redhat.com> - 0.10-42
- Init script fixes (#237973)

* Mon Mar 26 2007 David Cantrell <dcantrell@redhat.com> - 0.10-41
- Pass correct sockaddr size for salen parameter to getnameinfo() (#233900)
- Spec file cleanups per Fedora Packaging Guidelines

* Fri Feb 16 2007 David Cantrell <dcantrell@redhat.com> - 0.10-40
- Remove strlcat(), we don't use it or need it
- Close socket correctly in gethwid() (#229005)

* Fri Feb 09 2007 David Cantrell <dcantrell@redhat.com> - 0.10-39
- Fix build failures on x86_64 and ia64
- Remove parallel make flags
- Disable -Werror for now since flex-generated source fails miserably with it
- Remove yy_current_buffer from lease_token.l
- Added missing -fPIC to CFLAGS

* Thu Feb 08 2007 David Cantrell <dcantrell@redhat.com> - 0.10-38
- Fix up libdhcp6client patch so it doesn't copy the source then patch it
- Revert LOG_INFO changes back to LOG_DEBUG
- Move non-libdhcp6client patches to the main bugfix patch
- Remove the extra noise sent to the logging function
- Correct warnings so it compiles with -Werror
- Remove local htonl.h header, just use the /usr/include definitions
- Include <netinet/in.h> and remove inclusion of <linux/ipv6.h> and "htonl.h"
- Move dhcp6r source to its own patch file
- Put man page patches in to a single patch file
- Remove periods from the end of package summary lines (package review)
- Use preferred BuildRoot (package review)
- Only export the symbols we want in libdhcp6client (#216187)
- Keep flex-generated files for the debuginfo package

* Tue Feb 06 2007 David Cantrell <dcantrell@redhat.com> - 0.10-37
- Add missing ';;' on line 72 of dhcp6r init script

* Tue Feb 06 2007 David Cantrell <dcantrell@redhat.com> - 0.10-36
- Make dhcp6s and dhcp6r init scripts LSB compliant

* Mon Nov 27 2006 David Cantrell <dcantrell@redhat.com> - 0.10-35
- server6_addr.conf is not required for dhcp6s
- Resolves: rhbz#217309
- Man page for dhcp6s.conf should reference server-preference
- Resolves: rhbz#217308

* Thu Nov 16 2006 David Cantrell <dcantrell@redhat.com> - 0.10-34
- Set permission of libdhcp6client.so.1 to 0755 (#215911)

* Tue Oct 31 2006 David Cantrell <dcantrell@redhat.com> - 0.10-33
- spec file cleanup (remove NODEBUGINFO, useless code, etc)
- Patch rollup since a lot of the later patches overwrote previous patches
- Put typedef for dhcp_state_e before it's used in libdhcp_control.h (#212612)
- Include <sys/queue.h> rather than the old BSD queue.h in the source

* Fri Sep 29 2006 David Cantrell <dcantrell@redhat.com> - 0.10-32
- Line continuation slashes for init script description (#204713)

* Fri Aug 18 2006 Jesse Keating <jkeating@redhat.com> - 0.10-31
- rebuilt with latest binutils to pick up 64K -z commonpagesize on ppc*
  (#203001)

* Tue Jul 18 2006 Jason Vas Dias <jvdias@redhat.com> - 0.10-30
- fix bug 196429: 
  Allow clients from dhcpv6-0.10<=16 to get addresses. 
  >16, the server sent the prefix length; this is now
  conditional on the client sending the DHC6OPT_REQUEST_PREFIX,
  and can be disabled by the 'use-ra-prefix' dhcp6c.conf or 
  dhcp6s.conf setting. With the upstream version, the only
  way to set the clients' address prefixes was by router
  advertisement.

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 0.10-29.1
- rebuild

* Wed Jun 28 2006 Peter Jones <pjones@redhat.com> - 0.10-29
- getnameinfo needs the size of the incoming data, not NS_MAXHOST

* Thu Jun 22 2006 David Cantrell <dcantrell@redhat.com> - 0.10-28
- If link is down, exit rather than loop indefinitely (#195250)

* Tue Jun 20 2006 Peter Jones <pjones@redhat.com> - 0.10-27
- don't patch using autoconf, do it in the spec file so it can be
  patched on top of

* Thu Jun 08 2006 Jason Vas Dias<jvdias@redhat.com> 0.10-26
- libdhcp6client fix to retry bind() to linklocal address
  on EADDRNOTAVAIL for up to 5 seconds to give kernel time
  to create linklocal address.

* Fri May 26 2006 Jason Vas Dias<jvdias@redhat.com> 0.10-24.1
- misc libdhcp6client fixes

* Fri May 19 2006 Jason Vas Dias<jvdias@redhat.com> 0.10-24
- build libdhcp6client with -soname

* Wed May 17 2006 Jason Vas Dias<jvdias@redhat.com> 0.10-22
- Thanks, Karsten. Now building with libdhcp6client enabled.

* Wed May 17 2006 Karsten Hopp <karsten@redhat.de> 0.10-21
- change buildrequires from openssl top openssl-devel so that
  the configure checks actually work

* Sun May 14 2006 Jason Vas Dias <jvdias@redhat.com> - 0.10-20
- Produce the libdhcp6client library for invoking dhcp6c from
  within other programs.

* Wed May 10 2006 Jason Vas Dias <jvdias@redhat.com> - 0.10-18
- Make server send client the IPv6 address prefix in address lease;
  make client use it 
- prevent netlink.c generating error log message for NLMSG_DONE
- fix netlink.c IFLA_PROTINFO handling now that kernel defines it
- fix memory leak in client6_addr create_iaid
- disable 'install -s' for binaries

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 0.10-16.1
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jason Vas Dias <jvdias@redhat.com> - 0.10-16
- rebuild for new gcc, glibc, glibc-kernheaders

* Sun Dec 18 2005 Jason Vas Dias<jvdias@redhat.com> - 0.10-15.2
- rebuild for new gcc & flex

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Wed Nov  9 2005 Tomas Mraz <tmraz@redhat.com> - 0.10-15
- rebuilt with new openssl

* Mon Aug 15 2005 Jason Vas Dias <jvdias@redhat.com>
- fix bug 165882: allow client to configure an interface which
  does not have an IPv4 address ( use getifaddrs instead of
  ioctl(sockfd, SIOGIFCONF, ...)
- fix bug 165884 (possibly!): force use of glibc's getifaddrs,
  not internal getifaddrs implementation

* Fri Apr 01 2005 Florian La Roche <laroche@redhat.com>
- made perms for /var/lib/dhcpv6 the same

* Fri Mar 25 2005 Florian La Roche <laroche@redhat.com>
- add "exit 0" to postun script

* Thu Jan 13 2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-11
- Fix misc. compiler warnings and ms-dos formatted man-pages

* Wed Jan 12 2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-11
- Add 'prefix-delegation-interface' option to allow write
- of radvd interface configuration other than that for 
- the interface the lease was received on.

* Mon Jan 10 2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-10
- Fix bug 144585: dhcp6c wasn't writing radvd.conf in prefix delegation mode

* Sun Jan 9  2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-10
- Add Relay Agent support. Thanks to  Brian Bluesker<bbuesker@qualcomm.com>
- for the patch to add relay support to the server and for submitting the 
- patch originally contributed by Cristian Cadar of NEC Europe to 
- DHCPv6-developer  mailing list.

* Fri Jan 7  2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-9
- fix bug 143728: SEGV core on resolv.conf + radvd.conf update -
- yywrap()'s must return 1

* Mon Oct 18 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-7
- fix bug 136146: clean up code - prevent compiler warnings

* Mon Sep 13 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-6
- fix bug 132468 for bug 125712: invoke change_resolv_conf

* Mon Sep 13 2004 Bill Nottingham <notting@redhat.com> - 0.10-5
- don't run by default
- add chkconfig prereqs, postun script, etc.

* Thu Sep  2 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-3/4
- fixed missing %defattr for dhcpv6_client - bug 131638

* Mon Aug 30 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-2
- Split into two packages: dhcpv6-*, containing server only,
- and dhcpv6_client-*, containing client only.

* Thu Aug 26 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-1 
- Initial build.

